#!/usr/bin/env python3
# -*- coding: utf-8 -*-

# Шаблоны и прочие константы.


# Количественные числительные
# Родительный падеж
r_ca = (
  (
    (
      (
        'ноля',
        ('тысячи', 'тысяч'),
        ('миллиона', 'миллионов'),
        ('миллиарда', 'миллиардов'),
        ('триллиона', 'триллионов'),
        ('квадриллиона', 'квадриллионов'),
        ('квинтиллиона', 'квинтиллионов'),
        ('секстиллиона', 'секстиллионов'),
        ('септиллиона', 'септиллионов'),
        ('октиллиона', 'октиллионов')
      ),
      'ста',
      'двухсот',
      'трёхсот',
      'четырехсот',
      'пятисот',
      'шестисот',
      'семисот',
      'восьмисот',
      'девятисот'
    ),
    'десяти',
    'двадцати',
    'тридцати',
    'сорока',
    'пятидесяти',
    'шестидесяти',
    'семидесяти',
    'восьмидесяти',
    'девяноста'
  ),
  ('одного', 'одиннадцати'),
  ('двух', 'двенадцати'),
  ('трёх', 'тринадцати'),
  ('четырёх', 'четырнадцати'),
  ('пяти', 'пятнадцати'),
  ('шести', 'шестнадцати'),
  ('семи', 'семнадцати'),
  ('восьми', 'восемнадцати'),
  ('девяти', 'девятнадцати')
)
# Дательный падеж
d_ca = (
  (
    (
      (
        'нолю',
        ('тысяче', 'тысячам'),
        ('миллиону', 'миллионам'),
        ('миллиарду', 'миллиардам'),
        ('триллиону', 'триллионам'),
        ('квадриллиону', 'квадриллионам'),
        ('квинтиллиону', 'квинтиллионам'),
        ('секстиллиону', 'секстиллионам'),
        ('септиллиону', 'септиллионам'),
        ('октиллиону', 'октиллионам')
      ),
      'ста',
      'двумстам',
      'тремстам',
      'четыремстам',
      'пятистам',
      'шестистам',
      'семистам',
      'восьмистам',
      'девятистам'
    ),
    'десяти',
    'двадцати',
    'тридцати',
    'сорока',
    'пятидесяти',
    'шестидесяти',
    'семидесяти',
    'восьмидесяти',
    'девяноста'
  ),
  ('одному', 'одиннадцати'),
  ('двум', 'двенадцати'),
  ('трём', 'тринадцати'),
  ('четырём', 'четырнадцати'),
  ('пяти', 'пятнадцати'),
  ('шести', 'шестнадцати'),
  ('семи', 'семнадцати'),
  ('восьми', 'восемнадцати'),
  ('девяти', 'девятнадцати')
)
# Творительный падеж
t_ca = (
  (
    (
      (
        'нолём',
        ('тысячей', 'тысячами'),
        ('миллионом', 'миллионами'),
        ('миллиардом', 'миллиардами'),
        ('триллионом', 'триллионами'),
        ('квадриллионом', 'квадриллионами'),
        ('квинтиллионом', 'квинтиллионами'),
        ('секстиллионом', 'секстиллионами'),
        ('септиллионом', 'септиллионами'),
        ('октиллионом', 'октиллионами')
      ),
      'ста',
      'двумя стами',
      'тремя стами',
      'четырьмя стами',
      'пятьюстами',
      'шестьюстами',
      'семьюстами',
      'восемьюстами',
      'девятьюстами'
    ),
    'десятью',
    'двадцатью',
    'тридцатью',
    'сорока',
    'пятьюдесятью',
    'шестьюдесятью',
    'семьюдесятью',
    'восемьюдесятью',
    'девяноста'
  ),
  ('одним', 'одиннадцатью'),
  ('двумя', 'двенадцатью'),
  ('тремя', 'тринадцатью'),
  ('четырьмя', 'четырнадцатью'),
  ('пятью', 'пятнадцатью'),
  ('шестью', 'шестнадцатью'),
  ('семью', 'семнадцатью'),
  ('восемью', 'восемнадцатью'),
  ('девятью', 'девятнадцатью')
)
# Винительный падеж
v_ca = (
  (
    (
      (
        'ноль',
        ('тысячу', 'тысяч'),
        ('миллион', 'миллионов'),
        ('миллиард', 'миллиардов'),
        ('триллион', 'триллионов'),
        ('квадриллион', 'квадриллионов'),
        ('квинтиллион', 'квинтиллионов'),
        ('секстиллион', 'секстиллионов'),
        ('септиллион', 'септиллионов'),
        ('октиллион', 'октиллионов')
      ),
      'сто',
      'двести',
      'триста',
      'четыреста',
      'пятьсот',
      'шестьсот',
      'семьсот',
      'восемьсот',
      'девятьсот'
    ),
    'десять',
    'двадцать',
    'тридцать',
    'сорок',
    'пятьдесят',
    'шестьдесят',
    'семьдесят',
    'восемьдесят',
    'девяносто'
  ),
  ('один', 'одиннадцать'),
  ('два', 'двенадцать'),
  ('три', 'тринадцать'),
  ('четыре', 'четырнадцать'),
  ('пять', 'пятнадцать'),
  ('шесть', 'шестнадцать'),
  ('семь', 'семнадцать'),
  ('восемь', 'восемнадцать'),
  ('девять', 'девятнадцать')
)
# Предложный падеж
p_ca = (
  (
    (
      (
        'ноле',
        ('тысяче', 'тысячах'),
        ('миллионе', 'миллионах'),
        ('миллиарде', 'миллиардах'),
        ('триллионе', 'триллионах'),
        ('квадриллионе', 'квадриллионах'),
        ('квинтиллионе', 'квинтиллионах'),
        ('секстиллионе', 'секстиллионах'),
        ('септиллионе', 'септиллионах'),
        ('октиллионе', 'октиллионах')
      ),
      'ста',
      'двухстах',
      'трехстах',
      'четырёхстах',
      'пятистах',
      'шестистах',
      'семистах',
      'восьмистах',
      'девятистах'
    ),
    'десяти',
    'двадцати',
    'тридцати',
    'сорока',
    'пятидесяти',
    'шестидесяти',
    'семидесяти',
    'восьмидесяти',
    'девяноста'
  ),
  ('одном', 'одиннадцати'),
  ('двух', 'двенадцати'),
  ('трёх', 'тринадцати'),
  ('четырёх', 'четырнадцати'),
  ('пяти', 'пятнадцати'),
  ('шести', 'шестнадцатью'),
  ('семи', 'семнадцати'),
  ('восьми', 'восемнадцати'),
  ('девяти', 'девятнадцати')
)

# Порядковые числительные
# Именительный падеж мужского рода
i_mu = (
  (
    (
      (
        'нулевой',
        'тысячный',
        'двухтысячный',
        'трёхтысячный',
        'четырёхтысячный',
        'пятитысячный',
        'шеститысячный',
        'семитысячный',
        'восьмитысячный',
        'девятитысячный'
      ),
      'сотый',
      'двухсотый',
      'трёхсотый',
      'четырёхсотый',
      'пятисотый',
      'шестисотый',
      'семисотый',
      'восьмисотый',
      'девятисотый'
    ),
    'десятый',
    'двадцатый',
    'тридцатый',
    'сороковой',
    'пятидесятый',
    'шестидесятый',
    'семидесятый',
    'восьмидесятый',
    'девяностый'
  ),
  ('первый', 'одиннадцатый'),
  ('второй', 'двенадцатый'),
  ('третий', 'тринадцатый'),
  ('четвёртый', 'четырнадцатый'),
  ('пятый', 'пятнадцатый'),
  ('шестой', 'шестнадцатый'),
  ('седьмой', 'семнадцатый'),
  ('восьмой', 'восемнадцатый'),
  ('девятый', 'девятнадцатый')
)
# Именительный падеж среднего рода
i_sr = (
  (
    (
      (
        'нулевое',
        'тысячное',
        'двухтысячное',
        'трёхтысячное',
        'четырёхтысячное',
        'пятитысячное',
        'шеститысячное',
        'семитысячное',
        'восьмитысячное',
        'девятитысячное'
      ),
      'сотое',
      'двухсотое',
      'трёхсотое',
      'четырёхсотое',
      'пятисотое',
      'шестисотое',
      'семисотое',
      'восьмисотое',
      'девятисотое'
    ),
    'десятое',
    'двадцатое',
    'тридцатое',
    'сороковой',
    'пятидесятое',
    'шестидесятое',
    'семидесятое',
    'восьмидесятое',
    'девяностое'
  ),
  ('первое', 'одиннадцатое'),
  ('второе', 'двенадцатое'),
  ('третье', 'тринадцатое'),
  ('четвёртое', 'четырнадцатое'),
  ('пятое', 'пятнадцатое'),
  ('шестое', 'шестнадцатое'),
  ('седьмое', 'семнадцатое'),
  ('восьмое', 'восемнадцатое'),
  ('девятое', 'девятнадцатое')
)
# Именительный падеж женского рода
i_zh = (
  (
    (
      (
        'нулевая',
        'тысячная',
        'двухтысячная',
        'трёхтысячная',
        'четырёхтысячная',
        'пятитысячная',
        'шеститысячная',
        'семитысячная',
        'восьмитысячная',
        'девятитысячная'
      ),
      'сотая',
      'двухсотая',
      'трёхсотая',
      'четырёхсотая',
      'пятисотая',
      'шестисотая',
      'семисотая',
      'восьмисотая',
      'девятисотая'
    ),
    'десятая',
    'двадцатая',
    'тридцатая',
    'сороковая',
    'пятидесятая',
    'шестидесятая',
    'семидесятая',
    'восьмидесятая',
    'девяностая'
  ),
  ('первая', 'одиннадцатая'),
  ('вторая', 'двенадцатая'),
  ('третья', 'тринадцатая'),
  ('четвёртая', 'четырнадцатая'),
  ('пятая', 'пятнадцатая'),
  ('шестая', 'шестнадцатая'),
  ('седьмая', 'семнадцатая'),
  ('восьмая', 'восемнадцатая'),
  ('девятая', 'девятнадцатая')
)
# Именительный падеж множественного числа
i_mn = (
  (
    (
      (
        'нулевые',
        'тысячные',
        'двухтысячные',
        'трёхтысячные',
        'четырёхтысячные',
        'пятитысячные',
        'шеститысячные',
        'семитысячные',
        'восьмитысячные',
        'девятитысячные'
      ),
      'сотые',
      'двухсотые',
      'трёхсотые',
      'четырёхсотые',
      'пятисотые',
      'шестисотые',
      'семисотые',
      'восьмисотые',
      'девятисотые'
    ),
    'десятые',
    'двадцатые',
    'тридцатые',
    'сороковые',
    'пятидесятые',
    'шестидесятые',
    'семидесятые',
    'восьмидесятые',
    'девяностые'
  ),
  ('первые', 'одиннадцатые'),
  ('вторые', 'двенадцатые'),
  ('третьи', 'тринадцатые'),
  ('четвёртые', 'четырнадцатые'),
  ('пятые', 'пятнадцатые'),
  ('шестые', 'шестнадцатые'),
  ('седьмые', 'семнадцатые'),
  ('восьмые', 'восемнадцатые'),
  ('девятые', 'девятнадцатые')
)
# Родительный падеж мужского рода
r_mu = (
  (
    (
      (
        'нулевого',
        'тысячного',
        'двухтысячного',
        'трёхтысячного',
        'четырёхтысячного',
        'пятитысячного',
        'шеститысячного',
        'семитысячного',
        'восьмитысячного',
        'девятитысячного'
      ),
      'сотого',
      'двухсотого',
      'трёхсотого',
      'четырёхсотого',
      'пятисотого',
      'шестисотого',
      'семисотого',
      'восьмисотого',
      'девятисотого'
    ),
    'десятого',
    'двадцатого',
    'тридцатого',
    'сорокового',
    'пятидесятого',
    'шестидесятого',
    'семидесятого',
    'восьмидесятого',
    'девяностого'
  ),
  ('первого', 'одиннадцатого'),
  ('второго', 'двенадцатого'),
  ('третьего', 'тринадцатого'),
  ('четвёртого', 'четырнадцатого'),
  ('пятого', 'пятнадцатого'),
  ('шестого', 'шестнадцатого'),
  ('седьмого', 'семнадцатого'),
  ('восьмого', 'восемнадцатого'),
  ('девятого', 'девятнадцатого')
)
# Родительный падеж женского рода
r_zh = (
  (
    (
      (
        'нулевой',
        'тысячной',
        'двухтысячной',
        'трёхтысячной',
        'четырёхтысячной',
        'пятитысячной',
        'шеститысячной',
        'семитысячной',
        'восьмитысячной',
        'девятитысячной'
      ),
      'сотой',
      'двухсотой',
      'трёхсотой',
      'четырёхсотой',
      'пятисотой',
      'шестисотой',
      'семисотой',
      'восьмисотой',
      'девятисотой'
    ),
    'десятой',
    'двадцатой',
    'тридцатой',
    'сороковой',
    'пятидесятой',
    'шестидесятой',
    'семидесятой',
    'восьмидесятой',
    'девяностой'
  ),
  ('первой', 'одиннадцатой'),
  ('второй', 'двенадцатой'),
  ('третьей', 'тринадцатой'),
  ('четвёртой', 'четырнадцатой'),
  ('пятой', 'пятнадцатой'),
  ('шестой', 'шестнадцатой'),
  ('седьмой', 'семнадцатой'),
  ('восьмой', 'восемнадцатой'),
  ('девятой', 'девятнадцатой')
)
# Родительный падеж множественного числа
r_mn = (
  (
    (
      (
        'нулевых',
        'тысячных',
        'двухтысячных',
        'трёхтысячных',
        'четырёхтысячных',
        'пятитысячных',
        'шеститысячных',
        'семитысячных',
        'восьмитысячных',
        'девятитысячных'
      ),
      'сотых',
      'двухсотых',
      'трёхсотых',
      'четырёхсотых',
      'пятисотых',
      'шестисотых',
      'семисотых',
      'восьмисотых',
      'девятисотых'
    ),
    'десятых',
    'двадцатых',
    'тридцатых',
    'сороковых',
    'пятидесятых',
    'шестидесятых',
    'семидесятых',
    'восьмидесятых', 
    'девяностых'
  ),
  ('первых', 'одиннадцатых'),
  ('вторых', 'двенадцатых'),
  ('третьих', 'тринадцатых'),
  ('четвёртых', 'четырнадцатых'),
  ('пятых', 'пятнадцатых'),
  ('шестых', 'шестнадцатых'),
  ('седьмых', 'семнадцатых'),
  ('восьмых', 'восемнадцатых'),
  ('девятых', 'девятнадцатых')
)
# Дательный падеж мужского рода
d_mu = (
  (
    (
      (
        'нулевому',
        'тысячному',
        'двухтысячному',
        'трёхтысячному',
        'четырёхтысячному',
        'пятитысячному',
        'шеститысячному',
        'семитысячному',
        'восьмитысячному',
        'девятитысячному'
      ),
      'сотому',
      'двухсотому',
      'трёхсотому',
      'четырёхсотому',
      'пятисотому',
      'шестисотому',
      'семисотому',
      'восьмисотому',
      'девятисотому'
    ),
    'десятому',
    'двадцатому',
    'тридцатому',
    'сороковому',
    'пятидесятому',
    'шестидесятому',
    'семидесятому',
    'восьмидесятому',
    'девяностому'
  ),
  ('первому', 'одиннадцатому'),
  ('второму', 'двенадцатому'),
  ('третьему', 'тринадцатому'),
  ('четвёртому', 'четырнадцатому'),
  ('пятому', 'пятнадцатому'),
  ('шестому', 'шестнадцатому'),
  ('седьмому', 'семнадцатому'),
  ('восьмому', 'восемнадцатому'),
  ('девятому', 'девятнадцатому')
)
# Творительный падеж мужского рода
t_mu = (
  (
    (
      (
        'нулевым',
        'тысячным',
        'двухтысячным',
        'трёхтысячным',
        'четырёхтысячным',
        'пятитысячным',
        'шеститысячным',
        'семитысячным',
        'восьмитысячным',
        'девятитысячным'
      ),
      'сотым',
      'двухсотым',
      'трёхсотым',
      'четырёхсотым',
      'пятисотым',
      'шестисотым',
      'семисотым',
      'восьмисотым',
      'девятисотым'
    ),
    'десятым',
    'двадцатым',
    'тридцатым',
    'сороковым',
    'пятидесятым',
    'шестидесятым',
    'семидесятым',
    'восьмидесятым',
    'девяностым'
  ),
  ('первым', 'одиннадцатым'),
  ('вторым', 'двенадцатым'),
  ('третьим', 'тринадцатым'),
  ('четвёртым', 'четырнадцатым'),
  ('пятым', 'пятнадцатым'),
  ('шестым', 'шестнадцатым'),
  ('седьмым', 'семнадцатым'),
  ('восьмым', 'восемнадцатым'),
  ('девятым', 'девятнадцатым')
)
# Творительный падеж множественного числа
t_mn = (
  (
    (
      (
        'нулевыми',
        'тысячными',
        'двухтысячными',
        'трёхтысячными',
        'четырёхтысячными',
        'пятитысячными',
        'шеститысячными',
        'семитысячными',
        'восьмитысячными',
        'девятитысячными'
      ),
      'сотыми',
      'двухсотыми',
      'трёхсотыми',
      'четырёхсотыми',
      'пятисотыми',
      'шестисотыми',
      'семисотыми',
      'восьмисотыми',
      'девятисотыми'
    ),
    'десятыми',
    'двадцатыми',
    'тридцатыми',
    'сороковыми',
    'пятидесятыми',
    'шестидесятыми',
    'семидесятыми',
    'восьмидесятыми',
    'девяностыми'
  ),
  ('первыми', 'одиннадцатыми'),
  ('вторыми', 'двенадцатыми'),
  ('третьими', 'тринадцатыми'),
  ('четвёртыми', 'четырнадцатыми'),
  ('пятыми', 'пятнадцатыми'),
  ('шестыми', 'шестнадцатыми'),
  ('седьмыми', 'семнадцатыми'),
  ('восьмыми', 'восемнадцатыми'),
  ('девятыми', 'девятнадцатыми')
)
# Винительный падеж женского рода
v_zh = (
  (
    (
      (
        'нулевую',
        'тысячную',
        'двухтысячную',
        'трёхтысячную',
        'четырёхтысячную',
        'пятитысячную',
        'шеститысячную',
        'семитысячную',
        'восьмитысячную',
        'девятитысячную'
      ),
      'сотую',
      'двухсотую',
      'трёхсотую',
      'четырёхсотую',
      'пятисотую',
      'шестисотую',
      'семисотую',
      'восьмисотую',
      'девятисотую'
    ),
    'десятую',
    'двадцатую',
    'тридцатую',
    'сороковую',
    'пятидесятую',
    'шестидесятую',
    'семидесятую',
    'восьмидесятую',
    'девяностую'
  ),
  ('первую', 'одиннадцатую'),
  ('вторую', 'двенадцатую'),
  ('третью', 'тринадцатую'),
  ('четвёртую', 'четырнадцатую'),
  ('пятую', 'пятнадцатую'),
  ('шестую', 'шестнадцатую'),
  ('седьмую', 'семнадцатую'),
  ('восьмую', 'восемнадцатую'),
  ('девятую', 'девятнадцатую')
)
# Предложный падеж мужского рода
p_mu = (
  (
    (
      (
        'нулевом',
        'тысячном',
        'двухтысячном',
        'трёхтысячном',
        'четырёхтысячном',
        'пятитысячном',
        'шеститысячном',
        'семитысячном',
        'восьмитысячном',
        'девятитысячном'
      ),
      'сотом',
      'двухсотом',
      'трёхсотом',
      'четырёхсотом',
      'пятисотом',
      'шестисотом',
      'семисотом',
      'восьмисотом',
      'девятисотом'
    ),
    'десятом',
    'двадцатом',
    'тридцатом',
    'сороковом',
    'пятидесятом',
    'шестидесятом',
    'семидесятом',
    'восьмидесятом',
    'девяностом'
  ),
  ('первом', 'одиннадцатом'),
  ('втором', 'двенадцатом'),
  ('третьем', 'тринадцатом'),
  ('четвёртом', 'четырнадцатом'),
  ('пятом', 'пятнадцатом'),
  ('шестом', 'шестнадцатом'),
  ('седьмом', 'семнадцатом'),
  ('восьмом', 'восемнадцатом'),
  ('девятом', 'девятнадцатом')
)
# Сопоставление остальных форм
r_sr = r_mu
d_sr = d_mu
d_zh = r_zh
d_mn = t_mu
t_sr = t_mu
t_zh = r_zh
p_sr = p_mu
p_zh = r_zh
p_mn = r_mn

# Определение падежа по окончанию
mn_pad = {'е': i_mn, 'м': d_mn, 'х': r_mn, 'ми': t_mn}
mu_pad = {'': i_mu, 'а': r_mu, 'у': d_mu, 'ом': t_mu, 'е': p_mu, 'й': i_mu,
          'я': r_mu, 'ю': d_mu, 'ем': t_mu, 'и': p_mu}
sr_pad = {'е': i_sr, 'у': d_sr, 'ю': d_sr, 'я': r_sr, 'ем': t_sr, 'и': p_sr}
zh_pad = {'а': i_zh, 'ы': r_zh, 'е': d_zh, 'ой': t_zh, 'у': v_zh}
adj_pad = {'ий': i_mu, 'его': r_mu, 'ему': d_mu, 'им': t_mu, 'ем': p_mu,
           'ый': i_mu, 'ого': r_mu, 'ому': d_mu, 'ым': t_mu, 'ом': p_mu,
           'ее': i_sr, 'ое': i_sr, 'ая': i_zh, 'яя': i_zh, 'ей': r_zh,
           'ой': r_zh, 'ую': v_zh, 'юю': v_zh, 'ие': i_mn, 'им': d_mn,
           'их': r_mn, 'ими': t_mn, 'ые': i_mn, 'ым': d_mn,
           'ых': r_mn, 'ыми': t_mn}

months = (r' (января|февраля|марта|апреля|мая|июня|'
          r'июля|августа|сентября|октября|ноября|декабря)')

# Обозначения единиц измерения и числительных
units = (r"(%|°|'|℃|В\b|К\b|М\b|£|₽|\$|(|к|М|Г)(Гц|пк)|(к|м)г\b|"
         r"(|мк|к|с|м)м\b|(|к|с|м)м²|(|к|с|м)м³|(|к|М)т\b|(|к|М|Г)Вт\b|га\b|"
         r"сек\b|л\.с\.|л\b|а\.е\.|шт\.|ед\.|тыс\.|млн|млрд|трлн|атм\b)")
zh_units = ('т', 'кт', 'Мт', 'а.е.', 'л.с.', 'сек', "'", 'ед.', 'тыс.', 'шт.', 'атм')

# Падежные формы единиц измерения и числительных
# в единственном/множественном числе:
# именительный, родительный, дательный, творительный, предложный
# и форма именительного падежа для числительных 2, 3, 4
forms = {
  '%':     ('процент', 'процентов', 'процента', 'процентов',
            'проценту', 'процентам', 'процентом', 'процентами',
            'проценте', 'процентах', 'процента'),
  '°':     ('градус', 'градусов', 'градуса', 'градусов', 'градусу', 'градусам',
            'градусом', 'градусами', 'градусе', 'градусах', 'градуса'),
  '℃':     ('градус Цельсия', 'градусов Цельсия', 'градуса Цельсия',
            'градусов Цельсия', 'градусу Цельсия', 'градусам Цельсия',
            'градусом Цельсия', 'градусами Цельсия', 'градусе Цельсия',
            'градусах Цельсия', 'градуса Цельсия'),
  'В':     ('вольт', 'вольт', 'вольта', 'вольт', 'вольту', 'вольтам',
            'вольтом', 'вольтами', 'вольте', 'вольтах', 'вольта'),
  'К':     ('кельвин', 'кельвинов', 'кельвина', 'кельвинов',
            'кельвину', 'кельвинам', 'кельвином', 'кельвинами',
            'кельвине', 'кельвинах', 'кельвина'),
  '$':     ('доллар', 'долларов', 'доллара', 'долларов', 'доллару', 'долларам',
            'долларом', 'долларами', 'долларе', 'долларах', 'доллара'),
  'га':    ('гектар', 'гектаров', 'гектара', 'гектаров', 'гектару', 'гектарам',
            'гектаром', 'гектарами', 'гектаре', 'гектарах', 'гектара'),
  'кг':    ('килограмм', 'килограммов', 'килограмма', 'килограммов',
            'килограмму', 'килограммам', 'килограммом', 'килограммами',
            'килограмме', 'килограммах', 'килограмма'),
  'км':    ('километр', 'километров', 'километра', 'километров', 'километру',
            'километрам', 'километром', 'километрами', 'километре',
            'километрах', 'километра'),
  'мг':    ('миллиграмм' 'миллиграммов', 'миллиграмма', 'миллиграммов',
            'миллиграмму', 'миллиграммам', 'миллиграммом', 'миллиграммами',
            'миллиграмме', 'миллиграммах', 'миллиграмма'),
  'мм':    ('миллиметр', 'миллиметров', 'миллиметра', 'миллиметров',
            'миллиметру', 'миллиметрам', 'миллиметром', 'миллиметрами',
            'миллиметре', 'миллиметрах', 'миллиметра'),
  'см':    ('сантиметр', 'сантиметров', 'сантиметра', 'сантиметров',
            'сантиметру', 'сантиметрам', 'сантиметром', 'сантиметрами',
            'сантиметре', 'сантиметрах', 'сантиметра'),
  'тыс.':  ('тысяча', 'тысяч', 'тысячи', 'тысяч', 'тысяче',  'тысячам',
            'тысячей', 'тысячами', 'тысяче', 'тысячах', 'тысячи'),
  'млн':   ('миллион', 'миллионов', 'миллиона', 'миллионов', 'миллиону',
            'миллионам', 'миллионом', 'миллионами', 'миллионе', 'миллионах',
            'миллиона'),
  'млрд':  ('миллиард', 'миллиардов', 'миллиарда', 'миллиардов', 'миллиарду',
            'миллиардам', 'миллиардом', 'миллиардами', 'миллиарде',
            'миллиардах', 'миллиарда'),
  'трлн':  ('триллион', 'триллионов', 'триллиона', 'триллионов', 'триллиону',
            'триллионам', 'триллионом', 'триллионами', 'триллионе',
            'триллионах', 'триллиона'),
  'м':     ('метр', 'метров', 'метра', 'метров', 'метру', 'метрам',
            'метром', 'метрами', 'метре', 'метрах', 'метра'),
  'мкм':   ('микрометр', 'микрометров', 'микрометра', 'микрометров',
            'микрометру', 'микрометрам', 'микрометром', 'микрометрами',
            'микрометре', 'микрометрах', 'микрометра'),
  'кт':    ('килотонна', 'килотонн', 'килотонны', 'килотонн', 'килотонне',
            'килотоннам', 'килотонной', 'килотоннами', 'килотонне',
            'килотоннах', 'килотонны'),
  'Мт':    ('мегатонна', 'мегатонн', 'мегатонны', 'мегатонн', 'мегатонне',
            'мегатоннам', 'мегатонной', 'мегатоннами', 'мегатонне',
            'мегатоннах', 'мегатонны'),
  'т':     ('тонна', 'тонн', 'тонны', 'тонн', 'тонне', 'тоннам', 'тонной',
            'тоннами', 'тонне', 'тоннах', 'тонны'),
  'кВт':   ('киловатт', 'киловатт', 'киловатта', 'киловатт', 'киловатту',
            'киловаттам', 'киловаттом', 'киловаттами', 'киловатте',
            'киловаттах', 'киловатта'),
  'МВт':   ('мегаватт', 'мегаватт', 'мегаватта', 'мегаватт', 'мегаватту',
            'мегаваттам', 'мегаваттом', 'мегаваттами', 'мегаватте',
            'мегаваттах', 'мегаватта'),
  'ГВт':   ('гигаватт', 'гигаватт', 'гигаватта', 'гигаватт', 'гигаватту',
            'гигаваттам', 'гигаваттом', 'гигаваттами', 'гигаватте',
            'гигаваттах', 'гигаватта'),
  'Вт':    ('ватт', 'ватт', 'ватта', 'ватт', 'ватту', 'ваттам', 'ваттом',
            'ваттами', 'ватте', 'ваттах', 'ватта'),
  'кГц':   ('килогерц', 'килогерц', 'килогерца', 'килогерц', 'килогерцу',
            'килогерцам', 'килогерцем', 'килогерцами', 'килогерце',
            'килогерцах', 'килогерца'),
  'МГц':   ('мегагерц', 'мегагерц', 'мегагерца', 'мегагерц', 'мегагерцу',
            'мегагерцам', 'мегагерцем', 'мегагерцами', 'мегагерце',
            'мегагерцах', 'мегагерца'),
  'ГГц':   ('гигагерц', 'гигагерц', 'гигагерца', 'гигагерц', 'гигагерцу',
            'гигагерцам', 'гигагерцем', 'гигагерцами', 'гигагерце',
            'гигагерцах', 'гигагерца'),
  'Гц':    ('герц', 'герц', 'герца', 'герц', 'герцу', 'герцам', 'герцем',
            'герцами', 'герце', 'герцах', 'герца'),
  '₽':     ('рубль', 'рублей', 'рубля', 'рублей', 'рублю', 'рублям',
            'рублём', 'рублями', 'рубле', 'рублях', 'рубля'),
  '£':     ('фунт стерлингов', 'фунтов стерлингов', 'фунта стерлингов',
            'фунтов стерлингов', 'фунту стерлингов', 'фунтам стерлингов',
            'фунтом стерлингов', 'фунтами стерлингов', 'фунте стерлингов',
            'фунтах стерлингов', 'фунта стерлингов'),
  'а.е.':  ('астрономическая единица', 'астрономических единиц',
            'астрономической единицы', 'астрономических единиц',
            'астрономической единице', 'астрономическим единицам',
            'астрономической единицей', 'астрономическими единицами',
            'астрономической единице', 'астрономических единицах',
            'астрономические единицы'),
  'л.с.':  ('лошадиная сила', 'лошадиных сил', 'лошадиной силы',
            'лошадиных сил', 'лошадиной силе', 'лошадиным силам',
            'лошадиной силой', 'лошадиными силами', 'лошадиной силе',
            'лошадиных силах', 'лошадиные силы'),
  'л':     ('литр', 'литров', 'литра', 'литров', 'литре', 'литрам',
            'литром', 'литрами', 'литре', 'литрах', 'литра'),
  'сек':   ('секунда', 'секунд', 'секунды', 'секунд', 'секунде', 'секундам',
            'секундой', 'секундами', 'секунде', 'секундах', 'секунды'),
  'м²':    ('метр квадратный', 'метров квадратных', 'метра квадратного',
            'метров квадратных', 'метру квадратному', 'метрам квадратным',
            'метром квадратным', 'метрами квадратными', 'метре квадратном',
            'метрах квадратных', 'метра квадратных'),
  'мм²':   ('миллиметр квадратный', 'миллиметров квадратных',
            'миллиметра квадратного', 'миллиметров квадратных',
            'миллиметру квадратному', 'миллиметрам квадратным',
            'миллиметром квадратным', 'миллиметрами квадратными',
            'миллиметре квадратном', 'миллиметрах квадратных',
            'миллиметра квадратных'),
  'см²':   ('сантиметр квадратный', 'сантиметров квадратных',
            'сантиметра квадратного', 'сантиметров квадратных',
            'сантиметру квадратному', 'сантиметрам квадратным',
            'сантиметром квадратным', 'сантиметрами квадратными',
            'сантиметре квадратном', 'сантиметрах квадратных',
            'сантиметра квадратных'),
  'км²':   ('километр квадратный', 'километров квадратных',
            'километра квадратного', 'километров квадратных',
            'километру квадратному', 'километрам квадратным',
            'километром квадратным', 'километрами квадратными',
            'километре квадратном', 'километрах квадратных',
            'километра квадратных'),
  'м³':    ('метр кубический', 'метров кубических', 'метра кубического',
            'метров кубических', 'метру кубическому', 'метрам кубическим',
            'метром кубическим', 'метрами кубическими', 'метре кубическом',
            'метрах кубических', 'метра кубических'),
  'мм³':   ('миллиметр кубический', 'миллиметров кубических',
            'миллиметра кубического', 'миллиметров кубических',
            'миллиметру кубическому', 'миллиметрам кубическим',
            'миллиметром кубическим', 'миллиметрами кубическими',
            'миллиметре кубическом', 'миллиметрах кубических',
            'миллиметра кубических'),
  'см³':   ('сантиметр кубический', 'сантиметров кубических',
            'сантиметра кубического', 'сантиметров кубических',
            'сантиметру кубическому', 'сантиметрам кубическим',
            'сантиметром кубическим', 'сантиметрами кубическими',
            'сантиметре кубическом', 'сантиметрах кубических',
            'сантиметра кубических'),
  'км³':   ('километр кубический', 'километров кубических',
            'километра кубического', 'километров кубических',
            'километру кубическому', 'километрам кубическим',
            'километром кубическим', 'километрами кубическими',
            'километре кубическом', 'километрах кубических',
            'километра кубических'),
  "'":     ('минута', 'минут', 'минуты', 'минут', 'минуте', 'минутам',
            'минутой', 'минутами', 'минуте', 'минутах', 'минуты'),
  'шт.':   ('штука', 'штук', 'штуки', 'штук', 'штуке', 'штукам',
            'штукой', 'штуками', 'штуке', 'штуках', 'штуки'),
  'М':     ('мах', 'махов', 'маха', 'махов', 'маху', 'махам',
            'махом', 'махами', 'махе', 'махах', 'маха'),
  'ед.':   ('единица', 'единиц', 'единицы', 'единиц', 'единице', 'единицам',
            'единицей', 'единицами', 'единице', 'единицах', 'единицы'),
  'кпк':   ('килопарсек', 'килопарсеков', 'килопарсека', 'килопарсеков',
            'килопарсеку', 'килопарсекам', 'килопарсеком', 'килопарсеками',
            'килопарсеке', 'килопарсеках', 'килопарсека'),
  'Мпк':   ('мегапарсек', 'мегапарсеков', 'мегапарсека', 'мегапарсеков',
            'мегапарсеку', 'мегапарсекам', 'мегапарсеком', 'мегапарсеками',
            'мегапарсеке', 'мегапарсеках', 'мегапарсека'),
  'Гпк':   ('гигапарсек', 'гигапарсеков', 'гигапарсека', 'гигапарсеков',
            'гигапарсеку', 'гигапарсекам', 'гигапарсеком', 'гигапарсеками',
            'гигапарсеке', 'гигапарсеках', 'гигапарсека'),
  'пк':    ('парсек', 'парсеков', 'парсека', 'парсеков', 'парсеку', 'парсекам',
            'парсеком', 'парсеками', 'парсеке', 'парсеках', 'парсека'),
  'атм':   ('атмосфера', 'атмосфер', 'атмосферы', 'атмосфер', 'атмосфере',
            'атмосферам', 'атмосферой', 'атмосферами', 'атмосфере',
            'атмосферах', 'атмосферы')
}

# Шаблоны
samples_1 = (
  (r'\n{3,}', r'\n\n'), # Лишние пустые строки (не обязательно)
  (r'[‑–−—―]', '-'), # Тире разных видов
  (r'\u00A0|\u2009|\u202F', ' '), # Различные виды пробелов
  (r' {2,}', ' '), # Замена нескольких пробелов одним
  (r'(\A|\n) ', r'\1'), # Удаление пробела в начале строки
  (r' (\n|\Z)', r'\1'), # Удаление пробела в конце строки
  ('…', '...'), # Многоточие как один знак не выделяется при чтении паузой
  (r'[«»„"]', ''), # Шаблоны не рассчитаны на присутствие кавычек

  (r'(?<=\d)/(?=\d)', '_дробь_'),
  ('л\. с\.', 'л.с.'),
  (r' ?\& ?', ' and '),

  # Удаление пробелов между разрядами числа
  (r'(?<=\d) (?=\d{3}\b(?!-))', ''),
  (r'(\d+,)((\d{3})+) (\d{1,2}\b)', r'\1\2\4'),

  (r'(\d+|тыс\.) ?кв\. ?((|к|с|м)м)\b', r'\1 \2²'),
  (r'(\d+|тыс\.) ?куб\. ?((|к|с|м)м)\b', r'\1 \2³'),
  (r'(?<= кв)\.( (|кило|милли|санти)метр(а|ов))\b', r'адратных\1'),
  (r'(?<= куб)\.( (|кило|милли|санти)метр(а|ов))\b', r'ических\1'),

  (r'(?<!\d)(?<!\d )шт\.( [А-Я][а-я]+)\b', r'штат\1'),

  # Предполагаемый конец предложения: одна точка будет убрана с сокращением
  (r'\b(в|вв|\d+ ?г|\d+-й г|гг|др|д|п|э|долл|руб|кв|обл|\d+ ?л\.с|'
   r'тыс|ш|шт|чел|ед|рт\. ст)\.( [А-Я][ а-я]+|\n|\Z)', r'\1..\2'),

  (r"(°|')(\d{1,2})", r'\1 \2'),
  (r'''('\d{1,2})"''', r'\1сек'),
  (r' ?с\. ?ш\.', ' северной широты'),
  (r' ?ю\. ?ш\.', ' южной широты'),
  (r' ?в\. ?д\.', ' восточной долготы'),
  (r' ?з\. ?д\.', ' западной долготы'),

  (r'\bмск\b', 'по московскому времени'),
  (r' им\. ((|(|[А-Я]\. ?)[А-Я]\. ?)[А-Я][а-яё]+)', r' имени \1'),
  (r'\b(\d+ мм )рт\. ст\.', r'\1ртутного столба'),
  (r'(?<=\d)( ?%-н)(о([ей]|го|му?)|ая|ы(й|х|ми?))\b', r'-процентн\2'),
  (r'\b([Оо]к)\. (\d+)', r'\1оло \2'),
  (r'\b(\d*[02-9][234]|[234]) ?чел\.', r'\1 человека'),
  (r'\b((\d+,|)\d+ (тыс\. |млн |))чел\.', r'\1человек'),
  (r'([Бб]олее|[Мм]енее|[Оо]коло)( \d+) ?чел\.', r'\1\2 человек'),
  (r'([015-9]) ?чел\.', r'\1 человек'),
  (r'§§ ?\b', r'параграфы '),
  (r'§ ?\b', r'параграф '),
  ('˚', '°'),
  (r'° ?[CС]\b', '℃'),
  (r'\bUSD\b', '$ США'),
  (r'\bдолл\.', '$'),
  (r'\bруб\.', '₽'),
  (r'(млн|млрд|трлн)\.(?! [А-Я]|\n|\Z)', r'\1'),

  # Диапазон чисел звучит более чётко с пробелами 
  (r'\b(\d+)-(\d+)', r'\1 - \2'),
  (r'\b([IVX]+)-([IVX]+)\b', r'\1 - \2'),

  (r'(?<=\d) ?[×xXхХ] ?(?=\d)', ' на '),
  (r' ?± ?', ' плюс-минус '),
  (r' ?= ?', ' равно '),
  (r' ?≠ ?', ' не равно '),
  (r' ?≈ ?', ' приближённо равно '),
  (r' ?> ?', ' больше '),
  (r' ?< ?', ' меньше '),
  (r' ?(⩾|≥) ?', ' больше или равно '),
  (r' ?(⩽|≤) ?', ' меньше или равно '),
  (r' ?~(?=\d)', ' приблизительно '),
  (r' ?\+ ?', ' плюс '),
  (r'(?<!\w)-(?=\d)', 'минус '),

  # В названиях, обозначениях, номерах: правильное чтение букв и числительных
  (r'\b([A-Za-zА-Яа-я]+-\d+)\b', r'"\1"'), # Предотвращает склонение цифры
  (r'(?<=[0-9-.])Б', 'Бэ'),
  (r'\bБ(?=[0-9-.])', 'Бэ'),
  (r'([А-Яа-я]+(-?\d+|)[ -])Б\b', r'\1Бэ'),
  (r'([А-Яа-я]+(-?\d+|)[ -])В\b', r'\1Вэ'),
  (r'([А-Яа-я]+(-?\d+|)[ -])К\b', r'\1Ка'),
  (r'([А-Яа-я]+(-?\d+|)[ -])С\b', r'\1Эс'),
  (r'(?<=[-.])С\b', '"С"'),
  (r'(?<![А-Я])В(-?\d)', r'Вэ\1'),
  (r'(?<![А-Я])К(-?\d)', r'Ка\1'),
  (r'(?<![А-Я])М(-?\d)', r'Эм\1'),
  (r'\b(\d{3,}) ?М\b', r'\1 Эм'),
  (r'\bС(-?\d)', r'Эс\1'),
  (r'([0-9-])С([0-9-+])', r'\1Эс\2'),
  (r'\b([a-zA-Zа-яА-Я]-?\d+) (\D{4,})', r'\1_\2'),
  (r'\b([Вв] )№№ ?(?=\d+)\b', r'\1номерах_'),
  (r'\b([Вв] )№ ?(?=\d+)\b ', r'\1номере_'),
  (r'№№ ?(?=\d+)\b', 'номера_'),
  (r'№ ?(?=\d+)\b', 'номер_'),

  (r'(?<!\d)(\$|€|£|₽) (?=\d)', r'\1'),
  (r'\$((((\d+,|)\d+|) - |)(\d+,|)\d+) (тыс\.|млн|млрд|трлн)',
   r'\1_\6 долларов'),
  (r'£((((\d+,|)\d+|) - |)(\d+,|)\d+) (тыс\.|млн|млрд|трлн)',
   r'\1_\6 фунтов стерлингов'),
  (r'₽((((\d+,|)\d+|) - |)(\d+,|)\d+) (тыс\.|млн|млрд|трлн)', r'\1_\6 рублей'),
  (r'€((((\d+,|)\d+|) - |)(\d+,|)\d+) (тыс\.|млн|млрд|трлн)', r'\1_\6 евро'),
  (r'(\$|€|£|₽)((((\d+,|)\d+ - )|)(\d+,|)\d+)\b', r'\2_\1'),
  (r'_(\$|€|£|₽) (тысяч(|ами|а[мх]?|и)\b|(миллион|миллиард|триллион)'
   r'(|ами|а[мх]?|ов)\b)', r' \2 \1'),
  (r'((\s|\A|\(| |\.\.\.)((\d+,|)\d+|)[+-]?(\d+,|)\d+) ?' + units, r'\1_\6'),
  (r'(тыс\.|млн|млрд|трлн|тысяч[аиумйх]{,3}|миллион[ауеовмих]{,3}|'
   r'миллиард[ауеовмих]{,3}|триллион[ауеовмих]{,3}) ' + units, r'\1_\2'),
  ('[ _]€', ' евро'),

  # Неправильные наращения
  (r'(?<=\d-)ом\b', 'м'),
  (r'(?<=\d-)[ео]й\b', 'й'),
  (r'(?<=\d-)ая\b', 'я'),

  (r'\b([Пп]о ст)\.(?= \d)', r'\1атье'),
  (r'\b([Сс]т)\.(?= \d)', r'\1атья'),
  (r'\b([Чч])(\.|асть)( \d+)(?!-)\b', r'\1асть\3-я'),
  (r'\bп\.( \d+)\b', r'пункт\1-й'),
  (r'(([Вв] течение|[Сс]о?|[Дд]о|[Пп]осле) [IV]{1,3} кв)\.', r'\1артала'),
  (r'([Вв]о? [IV]{1,3} кв)\.', r'\1артале'),
  (r'([Кк]о? [IV]{1,3} кв)\.', r'\1арталу'),
  (r'\b([IV]{1,3} кв)\.', r'\1артал'),
  (r'\bкв\.( \d+)', r'квартира\1'),
  (r'\bд\.( \d+)', r'дом\1'),
  (r'\bул\.', 'улица'),
  (r'\bпр(-т|осп\.)', 'проспект'),
  (r'([А-Я][а-яё]+(ая|ую) обл)\.', r'\1асть'),
  (r'([А-Я][а-яё]+ой обл)\.', r'\1асти'),
  (r'\b([Вв] г)\.( [А-Я][а-яё]+)\b', r'\1ороде\2'),
  (r'\b([Дд]о|[Ии]з|[Оо]т) г\.( [А-Я][а-яё]+)\b', r'\1 города\2'),
  (r'\b(г)\.( [А-Я][а-яё]+)\b', r'\1ород\2'),

  # Часто вместо латиницы встречается кириллица
  (r'\bХХ( ?в(\.|ек(|[аеу]|ом)\b))', r'20\1'),
  (r'\bХ( ?в(\.|ек(|[аеу]|ом)\b))', r'10\1'),

  (r'\bP\. ?((P\. ?)*)S\.', r'Пост-\1скриптум.'),
  (r'(P\. ?)(?=(P\. ?)*скриптум.)', 'пост-'),
  (r'\bPS\.', 'Пост-скриптум.'),
  (r'\b[Тт]\. ?е\.', 'то есть'),
  (r' т\. ?д\.', ' так далее'),
  (r' т\. ?п\.', ' тому подобное'),
  (r' т\. ?к\.', ' так как'),
  (r'в т\. ?ч\.', 'в том числе'),
  (r' н\. ?э\.', ' нашей эры'),
  (r' с\. ?г\.', ' сего года'),
  (r'(?<!\d )\bсм\.', 'смотри'),
  (r'\b[Пп]рим\. авт\.', 'примечание автора'),
  (r'\b[Пп]рим\. ред\.', 'примечание редактора'),
  (r'\b[Пп]рим\. пер(ев|)\.', 'примечание переводчика'),
  (r'\b[Аа]вт\.', 'автор'),
  (r'\b[Рр]ед\.', 'редактор'),
  (r'\b[Пп]рим\.', 'примечание'),
  (r'точк([аеийоу]{1,2}) над i', r'точк\1 над и-'),
  (r'\b([Дд])-(р|ра|ре|ром|ру)\b', r'\1окто\2'),
  (r'\b([Гг])-(н|на|не|ном|ну)\b', r'\1осподи\2'),
  (r'\b([Гг])-(жа|же|жи|жой|жу)\b', r'\1оспо\2'),
  (r'\b([Пп])-ов(а|е|у|ом|)\b', r'\1олуостров\2'),
  (r'\b([Кк]ол)-(ва|ве|во|вом|ву)\b', r'\1ичест\2'),
  (r'\bр-н(|а|е|ом|у)\b', r'район\1'),

  (r'\b[Вв]/ч\b', 'вэ-че'),
  (r'/(сек|с)\b', ' в секунду'),
  (r'/(час|ч)\b', ' в час'),
  (r'(?<=\d) ?V\b', '_В'),

  # (r'(\d)(½|¼|¾|⅕|⅖|⅗|⅘|⅙|⅚|⅐|⅛|⅜|⅝|⅞|⅑)', r'\1 и \2'),
  # ('½', 'одна вторая'),
  # ('⅓', 'одна треть'),
  # ('⅔', 'две трети'),
  # ('¼', 'одна четверть'),
  # ('¾', 'три четверти'),
  # ('⅕', 'одна пятая'),
  # ('⅖', 'две пятых'),
  # ('⅗', 'три пятых'),
  # ('⅘', 'четыре пятых'),
  # ('⅙', 'одна шестая'),
  # ('⅚', 'пять шестых'),
  # ('⅐', 'одна седьмая'),
  # ('⅛', 'одна восьмая'),
  # ('⅜', 'три восьмых'),
  # ('⅝', 'пять восьмых'),
  # ('⅞', 'семь восьмых'),
  # ('⅑', 'одна девятая'),

  # Предотвращает чтение некоторых числительных как порядковые: 2 века, 3 этажа
  (r'\b(\d*[02-9][234]|[234]) (век|квартал|класс|съезд|тип|этаж)а', r'\1_\2а'),

  (r'\b(\d+)-ю( [а-яё]+ми)\b', r'\1\2') # Излишнее наращение
)

samples_2 = (
  (r'(?<=\d)(в?в\.|г?г\.)', r' \1'),
  (r'(?<=[IVX])(в?в\.)', r' \1'),

  (r'\b([Яя]нвар[еюьям]{1,2}|[Фф]еврал[еюьям]{1,2}|[Мм]арт[аеуом]{0,2}|'
   r'[Аа]прел[еюьям]{1,2}|[Мм]а[йюяем]{1,2}|[Ии]ю[лн][еюьям]{1,2}|'
   r'[Аа]вгуст[аеуом]{0,2}|[Сс]ентябр[еюьям]{1,2}|[Оо]ктябр[еюьям]{1,2}|'
   r'[Нн]оябр[еюьям]{1,2}|[Дд]екабр[еюьям]{1,2}|[Зз]им[аеуой]{1,2}|'
   r'[Лл]ет[ауом]{1,2}|[Вв]есн[аеуыой]{1,2}|[Оо]сен[иью]{1,2})'
   r'( \d{4})(?!-го)\b', r'\1\2-го'),
  (r'([Зз]им[аеуыой]{1,2} \d+-го ?- ?\d+\b)(?!-го)', r'\1-го'),

  (r'([а-я]{3,8} )(\d+) ?- ?([а-я]{3,8} )(\d+-го)', r'\1\2-го \3\4'),

  (r'(месяц(|а|ев|ы) \d+)(?= г\.)', r'\1-го'),
  (r'(месяц(|а|ев|ы) \d+)( [-и] \d+)(?= гг\.)', r'\1-го\3-го'),
  (r'([Сс] \d+)( на \d+)' + months, r'\1-го\2 \3'),
  (r'([Пп]еред \d+)' + months, r'\1-м \2'),
  (r'\b(([Зз]а|[Нн]а) \d+)( - \d+)' + months, r'\1-е\3-е \4'),
  (r'\b([Зз]а|[Нн]а|[Пп]о)( \d+)' + months, r'\1\2-е \3'),
  (r'\b([Дд]о|[Нн]е позднее|[Нн]е ранее|[Пп]осле|[Сс]о?)( \d+)' + months,
   r'\1\2-го \3'),
  (r'\b([Кк]о?)( \d+)' + months, r'\1\2-му \3'),
  (r'\b(\d+)( [-и] | или )(\d+)' + months, r'\1-го\2\3-го \4'),
  (r'\b([19]) Мая\b', r'\1-е Мая'),
  (r'\b8 Марта', '8-е Марта'),

  (r'(?<!,)\b(1\d|[23]?[05-9])(?= числа)\b', r'\1-го'),

  (r'\b([Нн]ачало|([Нн]ачал|[Кк]онц)(а|е|ом|у)'
   r'|([Сс]ередин|[Пп]оловин)(а|е|ой|у|ы)|[Кк]онец)( \d+0) гг\.',
   r'\1\6-х годов'),

  (r'\b(([Зз]а|[Нн]а) \d\d?)\.(\d\d?)\.(\d\d(\d\d)?)\b', r'\1-е \3-го \4-го'),
  (r'\b([Кк] \d\d?)\.(\d\d?)\.(\d\d(\d\d)?)\b', r'\1-му \2-го \3-го'),
  (r'\b(\d\d?)\.(\d\d?)\.(\d\d(\d\d)?)\b', r'\1-го \2-го \3-го'),
  (r'(ноч[иь] со? \d+)( на \d+)', r'\1-го\2'),
  (r'\b([Сс]о? \d+)( по \d+-е)', r'\1-го\2'),

  (r'\b([Кк] \d+)( - \d+) (годам|гг\.)', r'\1-му\2-му годам'),
  (r'(\d+0-м )(гг\.)', r'\1годам'),
  (r'(-го )гг\.', r'\1годов'),

  (r'\b(гг\.|год(ы|ов|ами?|ах))( \d+ в)\.', r'\1\3ека'),
  (r'\b(([Вв]|[Оо]) \d+)( (-|или(| [во]))( \d+)) в\.', r'\1-м\3-м веке'),
  (r'\b(([Вв]|[Оо]) \d+)( (-|и(| [во])) \d+) вв\.', r'\1-м\3-м веках'),
  (r'\b(([Вв]|[Оо]) \d+) (в\.|веке\b)', r'\1-м веке'),
  (r'\b([Кк] \d+)(|-му) в\.', r'\1-му веку'),
  (r'([Дд]о|[Нн]е позднее|[Нн]е ранее|[Оо]коло|[Пп]осле|[Нн]ачиная с|'
   r'[Нн]а протяжении|([Нн]ачал|[Кк]онц)(а|е|ом|у)|[Кк]онец|'
   r'([Сс]ередин|[Пп]оловин)(а|е|ой|у|ы)|трет[иь]|четверт[иь])( \d+) в\.',
   r'\1\6-го века'),
  (r'\b([Кк] \d+)( - \d+) вв\.', r'\1-му\2-му векам'),
  (r'(([Вв] течение|[Дд]о|[Нн]а протяжении|[Пп]осле) \d+)( - \d+) вв\.',
   r'\1-го\3-го веков'),
  (r'\b([Сс] \d+)( по \d+) в\.', r'\1-го\2-й век'),
  (r'\b([Сс] \d+)( - \d+) вв\.', r'\1-го\2-го веков'),
  (r'\b(\d+)( [-и] \d+) вв\.', r'\1-й\2-й века'),
  (r'\b(\d+) в\.', r'\1-й век'),

  (r'\b([Оо]б? \d+) г\.', r'\1 годе'),
  (r'\b([Вв] \d+)(((, (а|но) не в)|( или| и)(| в)| -) \d+) (году|г\.)',
   r'\1-м\2-м году'),
  (r'\b([Кк] \d+)( (-|или) \d+) (году|г\.)', r'\1-му\2-му году'),
  (r'\b([Вв] (([а-я]+ |)[а-яё]+[ео]м[,]? |том же |)\d+) (году|г\.)',
   r'\1-м году'),
  (r'\b([Кк] (([а-я]+ |)[а-яё]+[ео]му[,]? |)\d+) (году|г\.)', r'\1-му году'),
  (r'\b([Пп]о \d+)(?= году)\b', r'\1-му'),

  (r'([Нн]ачиная с \d+)( и заканчивая \d+ годом)', r'\1-го\2'),
  (r'(([Мм]ежду|[Пп]о сравнению с) \d+ [-и] \d+) гг\.', r'\1 годами'),
  (r'(([Мм]ежду|[Пп]о сравнению с) \d+ [-и] \d+) г\.', r'\1 годом'),
  (r'([Пп]о сравнению с|[Пп]еред)( \d+) г\.', r'\1\2-м годом'),

  (r'\b([Вв] \d+)((,(| в)| -| и(| в)) \d+) (годах|гг\.)', r'\1-м\2-м годах'),
  (r'\b([Вв] \d+)(, \d+)((,| и) \d+) (годах|гг\.)', r'\1-м\2-м\3-м годах'),
  (r'([Оо]коло \d+)( - \d+) гг\.', r'\1-го\2-го годов'),
  (r'(\d+)( (или|и|-) \d+) (годы|гг\.)', r'\1-й\2-й годы'),

  (r'\b([Вв] \d+0)(|-х) (годах|гг\.)', r'\1-х годах'),
  (r'\b([Дд]о|[Пп]осле|[Сс]|конц[аеу]|[Кк]онец|концом)( \d+0) (годов|гг\.)',
   r'\1\2-х годов'),
  (r'\b([Сс] \d+)( по \d+)( год[ы]?)\b', r'\1-го\2-й\3'),
  (r'\b([Сс] \d+)( до \d+) г\.', r'\1-го\2-го года'),
  (r'\b([Сс] \d+)( по \d+) г\.', r'\1-го\2-й год'),
  (r'\b([Сс] \d+)( по \d+) гг\.', r'\1-го\2-й годы'),
  (r'\b([Сс] \d+)( на \d+) (год\b|г\.)', r'\1-го\2-й год'),
  (r'\b(\d+)( [-и] \d+ | )годов\b', r'\1-го\2годов'),
  (r'\b(\d+-го [-и] \d+)(?!-го)\b', r'\1-го'),
  (r'\b([Нн]ачало|([Нн]ачал|[Кк]онц)(а|е|ом|у)|([Сс]ередин|половин)(а|е|ой|у|ы)'
   r'|[Кк]онец)( \d+\b)(?!-)', r'\1\6-го'),

  (r'\b([Дд]о|[Нн]е позднее|[Нн]е ранее|[Оо]коло|[Пп]осле|[Сс])'
   r'( \d+)( ?г\.)', r'\1\2-го года'),
  (r'\b([Нн]е позднее|[Нн]е ранее|[Пп]осле|[Сс])'
   r'( \d+)(?= года)\b', r'\1\2-го'),
  (r'\b([Дд]о|[Нн]е позднее|[Нн]е ранее|[Оо]коло|[Пп]осле|[Сс])'
   r'( \d+)( (-|или) \d+) (года\b|г\.)', r'\1\2-го\3-го года'),
  (r'\b([Дд]о|[Нн]е позднее|[Нн]е ранее|[Оо]коло|[Пп]осле|[Сс])'
   r'( \d+)( - \d+) (годов\b|гг\.)', r'\1\2-го\3-го годов'),
  (r'\b(\d\d)\.(\d\d)\.(\d+)\b', r'\1-го \2-го \3-го'),
  (r'([Зз]им([аеуы]|ой) \d+)( - \d+)', r'\1-го\3-го'),

  (r'([Вв]о? [1-4])( (-|и( в|)) [1-4])( кварталах)', r'\1-м\2-м\5'),
  (r'([Вв]о? [1-4])( (-|или( в|)) [1-4])( квартале)', r'\1-м\2-м\5'),
  (r'\b([Сс]о? [1-4])( по [1-4] квартал)', r'\1-го\2'),
  (r'квартал(|а[х]?|ам[и]?|е|ом|у|ы)( \d+) г\.', r'квартал\1\2 года'),

  (r'\b([Дд]о|[Кк]о?|[Пп]осле|[Сс]о?)( \d+)( недел)(е|ей|и)\b', r'\1\2-й\3\4'),
  (r'\b(([Дд]о|[Пп]осле|[Сс]|ранее|позднее) \d+)( числа)\b', r'\1-го\3'),
  (r'\b([Кк] \d+)( числу)\b', r'\1-му\2'),

  (r'\b([Оо]т \d+) г\.', r'\1-го года'),
  (r'(\d+-го )г\.', r'\1года'),
  (r'([Сс] \d+)-м г\.', r'\1 годом'),
  (r'(\d+0)( (-|и|или) \d+0-е) (гг\.|годы)', r'\1-е\2 годы'),
  (r'(\d+0)(|-е) гг\.', r'\1-е годы'),
  (r'(\d+0) годы\b', r'\1-е годы'),
  (r'(\d+0-ми )гг\.', r'\1годами'),
  (r'(\d+0-х )гг\.', r'\1годов'),
  (r'\b([Кк] \d{3,4})( (-|или) \d{3,4})( годам)\b', r'\1-му\2-му\4'),

  (r'(\d+) г\.р\.', r'\1-го года рождения'),

  (r'\b(\d+)( годом)', r'\1-м\2'),
  # (r'(1\d|[02-9][05-9]|\b[5-9]) года\b', r'\1-го года'),
  (r'\b((1\d|20)\d\d) года\b', r'\1-го года'),
  (r'(1\d|[02-9][02-9]|\b[2-9])(| [а-яё]+[иы]й) год\b', r'\1-й\2 год'),
  (r'\b((1\d|20)\d\d)((| [а-яё]+[иы]й) год)\b', r'\1-й\3'), # Спорный шаблон
  (r'(\d+)(|-й) г\.', r'\1-й год'),
  (r'(\d+)( - \d+-й)', r'\1-й\2'),

  (r'(?<!,)\b(\d+) (и|или|-) (\d+)-(го|ми|му|х|ю|я)\b', r'\1-\4 \2 \3-\4'),
  (r'(?<!,)\b(\d+)(?=(, \d+)*, \d+-(го|ми|му|х|ю|я))', r'\1-\3'),

  (r'(\d)( ранга)\b', r'\1-го\2'),
  (r'([Пп]ункт(|а|е|у|ом)|[Сс]тать(я|е|ю|и|ей)) (?=\d+ )', r'\1_'),

  (r'\b([Сс]о?)( \d+)( по \d+) ((тысяче|сто)летие|поколение)\b',
   r'\1\2-го\3-е \4'),
  (r'\b([Вв]о?)( \d+)( - | и | или )(\d+) ((тысяче|сто)летиях|поколениях)',
   r'\1\2-м\3\4-м \5'),
  (r'([02-9]?[5-90]|1\d) ((тысяче|сто)летия|поколения)\b', r'\1-го \2')
)
samples_3 = (
  # Римские цифры
  (r'(Александр|Иван|Иоанн|Пав[е]?л|П[её]тр|Ф[её]дор|Васили|Лжедмитри|Никола|'
   r'Карл|Людовик)(|а|е|ем|й|ом|у|ю|я) ([IVX]+)\b',
   'm.group(1) + m.group(2) + " " + ordinal(roman2arabic(m.group(3)),'
   ' mu_pad[m.group(2)])'),
  (r'(Анн|Екатерин)(а|е|ой|у|ы) ([IVX]+)',
   'm.group(1) + m.group(2) + " " + ordinal(roman2arabic(m.group(3)), '
   'zh_pad[m.group(2)])'),
  (r'\b([IV]+) степени',
   'ordinal(roman2arabic(m.group(1)), r_zh) + " степени"'),
  (r'\b([IVX]+)( ((тысяче|сто)лети| поколени)(ем?|я|ю|и))\b',
   'ordinal(roman2arabic(m.group(1)), sr_pad[m.group(5)]) + m.group(2)'),
  (r'\b([IVX]+)( (век|квартал|класс|ранг|[Сс]ъезд|тип)(|а|е|у|ом))\b',
   'ordinal(roman2arabic(m.group(1)), mu_pad[m.group(4)]) + m.group(2)'),
  (r'\b([Вв] |[Оо]б? )([IVX]+) ',
   'm.group(1) + ordinal(roman2arabic(m.group(2)), p_mu) + " "'),
  (r'(?<![-.])\b([IVXCDM]+)( [А-Я]?[а-яё]+([иы]([ейх]|ми?)|'
   r'[ая]я|[ео](му?|го|[ей])|[ую]ю))\b',
   'ordinal(roman2arabic(m.group(1)), adj_pad[m.group(3)]) + m.group(2)'),
  (r'([A-Z][a-z]*[ -.]|[А-Я][а-я]*[ -.])([IVX]+)($|\n|[.,;:]| [^a-z])',
   'm.group(1) + roman2arabic(m.group(2)) + m.group(3)'),
  (r'([Дд]о|[Нн]е позднее|[Нн]е ранее|[Оо]коло|[Пп]осле|[Нн]ачиная с|'
   r'[Нн]а протяжении|([Нн]ачал|[Кк]онц)(а|е|ом|у)|'
   r'[Кк]онец|([Сс]ередин|[Пп]оловин)(а|е|ой|у|ы)|трет[иь]|четверт[иь])'
   r' ([IVX]+) ',
   'm.group(1) + " " + ordinal(roman2arabic(m.group(6)), r_mu) + " "'),
  # Порядковые числительные - даты и т. д.
  (r'\b(\d*1\d|\d*[02-9]?[02-9])( (век|квартал|класс|[Сс]ъезд|тип|этаж)'
   r'(|а|е|ом|у))\b', 'ordinal(m.group(1), mu_pad[m.group(4)]) + m.group(2)'),
  (r'(\d+)( зимни[еимх]{1,2}| летни[еимх]{1,2}|)( Олимпийски)(е|ми|м\b|х)\b',
   'ordinal(m.group(1), mn_pad[m.group(4)]) + m.group(2) + m.group(3) + '
   'm.group(4)'),
  (r'(\d+0)( - \d+0-е годы)', 'ordinal(m.group(1), i_mn) + m.group(2)'),
  (r'(\d+0)-е( годы)', 'ordinal(m.group(1), i_mn) + m.group(2)'),
  (r'([Кк] )(\d+0)-м\b', 'm.group(1) + ordinal(m.group(2), d_mn)'),
  (r'(\d+)( [-и] )(\d+) ((тысяче|сто)летия|поколения)\b',
   'ordinal(m.group(1), i_sr) + m.group(2) + ordinal(m.group(3), i_sr) + '
   '" " + m.group(4)'),
  (r'(11|[02-9])( ((тысяче|сто)лети|поколени)(е|и|ем|ю))\b',
   'ordinal(m.group(1), sr_pad[m.group(5)]) + m.group(2)'),
  (r'([Вв] )(\d+0)-е\b', 'm.group(1) + ordinal(m.group(2), i_mn)'),
  (r'(\d+)-е(?! [а-яё]+[аиы])\b', 'ordinal(m.group(1), i_sr)'), # Тестовый
  (r'(\d+0)( - \d+0-м годам)', 'ordinal(m.group(1), d_mn) + m.group(2)'),
  (r'(\d+0)-м( годам| числам)\b', 'ordinal(m.group(1), t_mu) + m.group(2)'),
  (r'(\d+)-ы?х ?-', 'ordinal(m.group(1), r_mn) + " "'),
  (r'\b([Вв]о? |[Нн]а |[Сс]квозь |[Чч]ерез )(\d+)-ю\b',
   'm.group(1) + ordinal(m.group(2), v_zh)'),
  (r'\b([Вв]о? |[Нн]а |[Оо]б? |[Пп]ри )(\d+)(|-м)( ?- ?| или | и )(\d+)-м\b',
   'm.group(1) + ordinal(m.group(2), p_mu) + m.group(4) + '
   'ordinal(m.group(5), p_mu)'),
  (r'\b(([Вв]о?|[Нн]а|[Оо]б?|[Пп]ри) \d+-м, )(\d+)-м\b',
   'm.group(1) + ordinal(m.group(3), p_mu)'),
  (r'\b([Вв]о?|[Нн]а|[Оо]б?|[Пп]ри)( [а-яё]+[ео]м | )(\d+)-м\b',
   'm.group(1) + m.group(2) + ordinal(m.group(3), p_mu)'),
  (r'\b([Сс] )(\d+)-м\b', 'm.group(1) + ordinal(m.group(2), t_mu)'),
  (r'(\d+)-му\b', 'ordinal(m.group(1), d_mu)'),
  (r'(\d+)-го\b', 'ordinal(m.group(1), r_mu)'),
  (r'(\d+)-ми\b', 'ordinal(m.group(1), t_mn)'),
  (r'([Мм]ежду )(\d+)-м и (\d+)-м\b',
   'm.group(1) + ordinal(m.group(2), t_mu) + " и " + '
   'ordinal(m.group(3), t_mu)'),
  (r'([Мм]ежду )(\d+)-й и (\d+)-й\b',
   'm.group(1) + ordinal(m.group(2), t_zh) + " и " + '
   'ordinal(m.group(3), t_zh)'),
  (r'\b(\d*1\d|\d*[02-9][015-9]|[015-9])-ы?х\b', 'ordinal(m.group(1), r_mn)'),
  (r'\b([Дд]о||[Кк]о?|[Пп]осле|[Оо]т|[Сс]о?) (\d+)-й\b',
   'm.group(1) + " " + ordinal(m.group(2), r_zh)'),
  (r'(\d+)( [-и] )(\d+)( годами| веками| (сто|тысяче)летиями)',
   'ordinal(m.group(1), t_mu) + m.group(2) + '
   'ordinal(m.group(3), t_mu) + m.group(4)'),
  (r'(\d+)-м (год(у|ах)|век(е|ах)|(сто|тысяче)лети(и|ях))',
   'ordinal(m.group(1), p_mu) + " " + m.group(2)'),
  (r'(\d+)-м( [а-яА-Я]+[иы]м)\b', 'ordinal(m.group(1), t_mu) + m.group(2)'),
  (r'(\d+)-м( [а-яА-Я]+[ео]м)\b', 'ordinal(m.group(1), p_mu) + m.group(2)'),
  (r'(\d+)-я\b', 'ordinal(m.group(1), i_zh)'),
  (r'(\d+)-ю\b', 'ordinal(m.group(1), v_zh)'),
  (r'(\d+)-й\b', 'ordinal(m.group(1), i_mu)'),
  (r'(\d+)( годовщин([аейоуы]{1,2}))\b',
   'ordinal(m.group(1), zh_pad[m.group(3)]) + m.group(2)'),
  (r'([Мм]ежду |[Пп]о сравнению с )(\d+)( - | и )(\d+)( годами| годом)\b',
   'm.group(1) + ordinal(m.group(2), t_mu) + m.group(3) + '
   'ordinal(m.group(4), t_mu) + m.group(5)'),
  (r'(\d+)-е' + months, 'ordinal(m.group(1), i_sr) + " " + m.group(2)'),
  (r'([Мм]ежду )(\d+)' + months + '( и )(\d+)' + months,
   'm.group(1) + ordinal(m.group(2), t_mu) + " " + m.group(3) + '
   'm.group(4) + ordinal(m.group(5), t_mu) + " " + m.group(6)'),
  (r'([Мм]ежду )(\d+) и (\d+)' + months,
   'm.group(1) + ordinal(m.group(2), t_mu) + " и " + '
   'ordinal(m.group(3), t_mu) + " " + m.group(4)'),
  (r'(датир(ован[а,о,ы]?|у[еюмтся]{1,4}) )(\d+)' + months,
   'm.group(1) + ordinal(m.group(3), t_mu) + " " + m.group(4)'),
  (r'\b(\d+)' + months, 'ordinal(m.group(1), r_mu) + " " + m.group(2)'),
  (r'\b(\d+)-[еи] сутки', 'ordinal(m.group(1), i_mn) + " сутки"'),
  # Десятичные дроби
  (r'\b([Пп]о сравнению с |[Вв]ладе[авеийлмтюшщья]{1,7} )(\d+),(\d+)\b',
   'm.group(1) + fraction(m.group(2), m.group(3), 3)'),
  (r'\b([Кк] |рав[аеоын]{2} |равня[аеилостья]{3,4} )(\d+),(\d+)\b',
   'm.group(1) + fraction(m.group(2), m.group(3), 2)'),
  (r'\b([Оо]б? |[Пп]ри )(\d+),(\d+)\b',
   'm.group(1) + fraction(m.group(2), m.group(3), 4)'),
  (r'\b([Вв] )(\d+),(\d+) раза\b',
   'm.group(1) + fraction(m.group(2), m.group(3), 5) + " раза"'),
  (r'\b([Вв] )(\d+),(\d+) - (\d+),(\d+) раза\b',
   'm.group(1) + fraction(m.group(2), m.group(3), 5) + " - " + '
   'fraction(m.group(4), m.group(5), 5) + " раза"'),
  (r'\b([Дд]иаметр[аеуом]{,2}|[Рр]азниц[аейуы]{1,2}|[Вв]ысот[аейоуы]{1,2}|'
   r'[Гг]лубин[аейоуы]{1,2}|[Дд]альност[иью]{1,2}|[Дд]истанци[яюией]{1,2}|'
   r'[Дд]лин[аейоуы]{1,2}|[Мм]асс[аейоуы]{1,2}|[Шш]ирин[аейоуы]{1,2}|'
   r'[Вв]ес[аемоу]{,2}|[Мм]ощност[иью]{1,2}|[Рр]асстояни[еимхюя]{1,2}|'
   r'[Сс]тоимост[иью]{1,2}|[Сс]корост[иью]{1,2}|[Дд]лительност[иью]{1,2}|'
   r'[Пп]родолжительност[иью]{1,2}|оцени[авеийлмстшыья]{,6}|'
   r'[Уу]далени[еимюя]{1,2}) в (\d+),(\d+)\b',
   'm.group(1) + " в " + fraction(m.group(2), m.group(3), 5)'),
#  (r'\b([Вв] )(\d+),(\d+)\b',
#   'm.group(1) + fraction(m.group(2), m.group(3), 4)'),
  (r'\b([Зз]а |состав[аеилотя]{2,4} )(\d+),(\d+)\b',
   'm.group(1) + fraction(m.group(2), m.group(3), 5)'),
  # Наращения при количественных числительных недопустимы, но распространены
  (r'\b(\d*[1-9]0|\d*1\d|\d*[02-9]?[569])-[т]?и\b',
   'cardinal(m.group(1), r_ca)'),
  (r'\b(\d*[02-9]?[234])-х\b', 'cardinal(m.group(1), r_ca)'),
  (r'(\d+)-ю ([а-яё]+ми)\b', 'cardinal(m.group(1), t_ca) + " " + m.group(2)'),
  (r'\b([Сс]о? )(\d*1[0-4]|\d*\d[5-9]|[5-9])-ю\b',
   'm.group(1) + cardinal(m.group(2), t_ca)')
)
samples_4 = (
  # Заголовки как правило не заканчиваются знаком препинания,
  # что приводит к слитному чтению со следующей строкой
  (r'(?<![.,:;!?-]|\n)(?<!\A)(\n|\Z)', r'.\1'),

  (r'\b(?<=[Мм])-(?=да)\b', ''), # Междометие "м-да"
  (r'\bID\b', 'ай-ди'),
  (r'ВКП\(б\)', 'вэкапэ-бэ'),
  (r'\bИИ\b', 'и- и-'),

  # Предотвращает неверное ударение
  (r'\b([Аа]виа)(?!ци)(?!нос)(?!тор)', r'\1-'),
  (r'\b([Гг]ипер|[Сс]упер)([а-яё]+)\b', r'\1-\2'),
  ('ноафриканск', 'но-африканск'),

  # Замена "е" на "ё" по сложному шаблону
  (r'\b([Вв]с)е(( это|) [а-яё]+([еи]т|[иы]ло)(|с[ья]))\b', r'\1ё\2'),
  (r'\b([Вв]с)е( [а-яё]+[еош]е|, что(бы|) |-таки)\b', r'\1ё\2'),
  (r'\b([Сс]оверш)е(нн(ая|о[ейм]|ому|ы[еймх]|ыми) [А-Я]?[а-яё]+([ео]м|ыми?|'
   r'[ая]ми|[ео]й))\b', r'\1ё\2'),
  (r'\b([Сс])е(стры [а-я]+(ли|[ую]т))\b', r'\1ё\2'),

  # Ударение (параметр "stress_marker=+" должен быть указан в RHVoice.conf)
  #(r'\b([Сс]о? ([а-яё-]+ |)сторон)ы\b', r'\1+ы'),
  #(r'\bс(амом [а-яё]+[ео]м)\b', r'с+\1'),
  #(r'\b([Нн]а (е[её] |его |)борт)у\b', r'\1+у'),
  #(r'\b(начал)(а ([а-яё]+ |)[а-я]+[аеиуя]ть(ся|))\b', r'\1+\2'),
  #(r'\b([Сс]т)(оит( ли | )[а-яё]+[аеиуыя]ть)', r'\1+\2'),
  #(r'\b([А-Я]?[а-яё]+[аеиуя]ть (|не )ст)оит\b', r'\1+оит'),
  #(r'([Ии]з-за войн)ы', r'\1+ы'),
  #(r'([Пп]олн)ым-полно', r'\1+ым-полн+о'),
  #(r'(-на-Дон)у\b', r'\1+у'),
  #(r'(-обр)(азн)', r'\1+\2'),
  #(r'\b([Кк]вази)([а-я]+)\b', r'\1-\2'),
  #(r'([Сс]мотр)(ите, (как|[кч]то))', r'\1+\2'),
  #(r'\b([Гг])(оре-[а-яё]+)\b', r'\1+\2'),
  #(r'([Сс])(амому [а-яё]+[ео]му)\b', r'\1+\2'),
  #(r'([Сс])(амого [а-яё]+[ео]го)\b', r'\1+\2'),
  #(r'([Сс])(амой [а-яё]+[ео]й)\b', r'\1+\2'),
  #('а́', '+а'),
  #('е́', '+е'),
  #('и́', '+и'),
  #('о́', '+о'),
  #('у́', '+у'),
  #('ы́', '+ы'),
  #('ю́', '+ю'),
  #('я́', '+я'),

  # Необязательная замена маркеров (используются при обработке)
  ('"', ''),
  ('_', ' ')
)

greekletters = 'ΑαΒβΓγΔδΕεΖζΗηΘθΙιΚκΛλΜμΝνΞξΟοΠπΡρΣσΤτΥυΦφΧχΨψΩως'
letternames = ('альфа', 'бета', 'гамма', 'дельта', 'эпсилон', 'дзета', 'эта',
               'тета', 'йота', 'каппа', 'лямбда', 'мю', 'ню', 'кси',
               'омикрон', 'пи', 'ро', 'сигма', 'тау', 'ипсилон', 'фи', 'хи',
               'пси', 'омега', 'сигма')

# pre_acc + в + числительное -> винительный падеж
pre_acc = ('вес', 'веса', 'весе', 'весу', 'весом',
           'вероятность', 'вероятности', 'вероятностью',
           'высота', 'высоты', 'высоте', 'высоту', 'высотой',
           'глубина', 'глубины', 'глубине', 'глубину', 'глубиной',
           'дальность', 'дальности', 'дальностью',
           'дальность стрельбы', 'дальности стрельбы', 'дальностью стрельбы',
           'диаметр', 'диаметра', 'диаметре', 'диаметру', 'диаметром',
           'дистанция', 'дистанции', 'дистанцией', 'дистанцию',
           'длительность', 'длительности', 'длительностью',
           'долг', 'долга', 'долге', 'долгу', 'долгом',
           'максимум', 'максимума', 'максимуме', 'максимуму', 'максимумом',
           'масса', 'массы', 'массе', 'массу', 'массой',
           'минимум', 'минимума', 'минимуме', 'минимуму', 'минимумом',
           'мощность', 'мощности', 'мощностью',
           'объем', 'объема', 'объеме', 'объему', 'объемом',
           'отметка', 'отметки', 'отметке', 'отметку', 'отметкой',
           'площадь', 'площади', 'площадью',
           'продолжительность', 'продолжительности', 'продолжительностью',
           'раз', 'раза', 'разу', 'разом',
           'разница', 'разницы', 'разнице', 'разницу', 'разницей',
           'расстояние', 'расстояния', 'расстоянии', 'расстоянию', 'расстоянием',
           'скорость', 'скорости', 'скоростью',
           'стоимость', 'стоимости', 'стоимостью',
           'сумма', 'суммы', 'сумме', 'сумму', 'суммой',
           'толщина', 'толщины', 'толщине', 'толщину', 'толщиной',
           'удаление', 'удаления', 'удалении', 'удалению', 'удалением',
           'уровень', 'уровня', 'уровне', 'уровню', 'уровнем',
           'цена', 'цены', 'цене', 'цену', 'ценой',
           'ширина', 'ширины', 'ширине', 'ширину', 'шириной',
           'обошелся', 'обошёлся','обошлась', 'обошлось', 'обошлись', 'обойтись',
           'обходится', 'обходятся', 'обойдется', 'обойдётся', 'обойдутся',
           'оценить', 'оценивать', 'оценил', 'оценила', 'оценили', 'оценивал',
           'оценивала', 'оценивали', 'оценю', 'оценишь', 'оценит', 'оценим',
           'оцените', 'оценят', 'оценив', 'оценивая', 'оценивается',
           'оценивался', 'оценивалась', 'оценивалось', 'оценивались')
